using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.BookingManager.Cqrs;

public class DeleteBookingByIdRequest
{
    public DeleteBookingByIdRequest(string id) => Id = id;
    public string Id { get; set; }
}

public record DeleteBookingByIdCommand(DeleteBookingByIdRequest Data) : IRequest<bool>;

public class DeleteBookingByIdHandler : IRequestHandler<DeleteBookingByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteBookingByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteBookingByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Booking
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        _context.Booking.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}